/*
    Help screen displayed on console while invoking zBoy from console mode with --help.
    This file is part of the zBoy project.
    Copyright (C) Mateusz Viste 2010,2011,2012
*/

void printhelp() {
  printf("\r\n");
  printf("      * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\r\n");
  printf("      *                                                                 *\r\n");
  printf("      *  zBoy - a full-featured GameBoy emulator for Linux and Windows  *\r\n");
  printf("      *             Copyright (C) Mateusz Viste 2010, 2011              *\r\n");
  printf("      *                                                                 *\r\n");
  printf("      * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\r\n");
  printf("\r\n");
  printf("+----------------------------------------------------------------------------+\r\n");
  printf("| Available keys:                                                            |\r\n");
  printf("|                                                                            |\r\n");
  printf("| Joypad actions | Keys mapping (on default keyboard mapping)                |\r\n");
  printf("|  UP            | Up arrow                                                  |\r\n");
  printf("|  DOWN          | Down arrow                                                |\r\n");
  printf("|  LEFT          | Left arrow                                                |\r\n");
  printf("|  RIGHT         | Right arrow                                               |\r\n");
  printf("|  START         | Enter (return)                                            |\r\n");
  printf("|  SELECT        | TAB                                                       |\r\n");
  printf("|  CTRL          | Button A                                                  |\r\n");
  printf("|  ALT           | Button B                                                  |\r\n");
  printf("|                                                                            |\r\n");
  printf("| Emulator's functions (using default keys assignements:                     |\r\n");
  printf("|  F1  - enables/disables game's background                                  |\r\n");
  printf("|  F2  - enables/disables game's sprites                                     |\r\n");
  printf("|  F3  - enables/disables game's window                                      |\r\n");
  printf("|  F5  - saves the current state of the game on disk (a.k.a. \"QuickSave\")    |\r\n");
  printf("|  F7  - loads the saved state of the game from disk (a.k.a. \"QuickLoad\")    |\r\n");
  printf("|  F8  - enables/disables autoscreenshot (does a screenshot every 10 seconds)|\r\n");
  printf("|  F9  - performs a PCX screenshot (snapshot saved to current directory)     |\r\n");
  printf("|  F10 - resets the CPU (restarts the game)                                  |\r\n");
  printf("|  ESC - quits the emulator                                                  |\r\n");
  printf("+----------------------------------------------------------------------------+\r\n");
  printf("\r\n");
  printf("+----------------------------------------------------------------------------+\r\n");
  printf("| Command-line usage:                                                        |\r\n");
  printf("|  zboy [--option1 --option2 ...] --rom file.gb                              |\r\n");
  printf("|                                                                            |\r\n");
  printf("| Available options:                                                         |\r\n");
  printf("|  --bootlogo      Boots over the Gameboy's internal ROM (which displays a   |\r\n");
  printf("|                  Nintendo logo), before executing the cartridge ROM.       |\r\n");
  printf("|  --eaglescale x  Scales the video screen x times using the EAGLE scaling   |\r\n");
  printf("|                  algorithm. Possible values are 2, 4, 6 or 8.              |\r\n");
  printf("|  --fpslimit x    Limit the FPS rendering to x frames per second. x must be |\r\n");
  printf("|                  in the range 1..60 (defaults to 60 FPS). This option will |\r\n");
  printf("|                  give odd results when combined with --nospeedlimit.       |\r\n");
  printf("|  --scale x       Scales the video screen x times. Possible values are      |\r\n");
  printf("|                  1..8 (defaults to 4 = 640x576).                           |\r\n");
  printf("|  --scale2x x     Scales the video screen x times using the Scale2x         |\r\n");
  printf("|                  algorithm. Possible values are 2, 4, 6 or 8.              |\r\n");
  printf("|  --scale3x x     Scales the video screen x times using the Scale3x         |\r\n");
  printf("|                  algorithm. Possible values are 3 or 6.                    |\r\n");
  printf("|  --palette name  Use an alternative palette of colors. Possible palettes   |\r\n");
  printf("|                  are: gbmicro or peasoup. The default one is gbmicro.      |\r\n");
  printf("|  --input file    Insert the filename where you redefine keys used to       |\r\n");
  printf("|                  emulate the GameBoy's joypad. See the list of available   |\r\n");
  printf("|                  scancodes in keyboard_list file.                          |\r\n");
  printf("|  --nocpuidle     Do not try to idle the CPU when the emulator have some    |\r\n");
  printf("|                  spare time. This might give better results on hi-latency  |\r\n");
  printf("|                  systems, at the cost of using the CPU at full speed.      |\r\n");
  printf("|  --nospeedlimit  Runs zBoy at full (unlimited) speed. This is not a good   |\r\n");
  printf("|                  idea if you want to play games, but might be useful for   |\r\n");
  printf("|                  some benchmarking needs.                                  |\r\n");
  printf("|  --showfps       Shows the FPS counter (frames per second) in the title    |\r\n");
  printf("|                  bar of zBoy's window.                                     |\r\n");
  printf("|  --noscreensaver Prohibits any screen saver to start while the emulator is |\r\n");
  printf("|                  running.                                                  |\r\n");
  printf("|  --hiscoresmem   This option will tell zBoy to memorize HiScores in games  |\r\n");
  printf("|                  that aren't able to do so by themselves (eg. Pipe Dream). |\r\n");
  printf("|  --rominfos      Displays various informations about the ROM before start. |\r\n");
  printf("|  --netplay x     Establish a 2 player session mode with the IP 'x'.        |\r\n");
  printf("|  --bindaddr x    In case of using --netplay, the --bindaddr parameter      |\r\n");
  printf("|                  allows to force the local IP (automatic by default).      |\r\n");
  printf("+----------------------------------------------------------------------------+\r\n");
  printf("\r\n");
  printf("         homepage: http://www.viste-family.net/mateusz/software/zboy/\r\n");
  printf("\r\n");
}
