#INCLUDE ONCE "fbnet/net.bi"

DIM SHARED AS UBYTE NetPollingState, NetRecvByteBuff, NetSendByteBuff, NeedToCloseNetworkThreads = 0
DIM SHARED NetPlayerIP(1 TO 4) AS UBYTE  ' will contain the IP of the remote peer

SUB NetworkCardPoll(BYVAL garbage AS ANY PTR)
  REM This thread is used to poll the UDP socket. This thread is
  REM obeying to the NetPollingState shared variable.
  REM The NetPollingState variable can contain following values:
  REM    00 = Try to read a byte from network, and put it into ByteBuff, then set NetPollingCommand to 01
  STATIC FirstRun AS UBYTE = 1
  STATIC hServer AS FDSOCKET
  STATIC AS SOCKADDR_IN Server, Client
  STATIC AS INTEGER retvalue

  IF FirstRun = 1 THEN
    hServer = NetSocket(AF_INET,SOCK_DGRAM,0)

    IF hServer < 0 THEN
      PRINT "ERROR: Could not create the socket!"
      END
    END IF

    Server.sin_family = AF_INET
    Server.sin_port = build_port(8764)
    Server.sin_addr = INADDR_ANY

    retvalue = NetBind(hServer, @Server)
    IF retvalue < 0 THEN
      PRINT "ERROR: Can't bind to the local port!"
      END
    END IF
    FirstRun = 0
  END IF

  DO
    IF NetPollingState = 0 THEN
      NetRead(hServer, @NetRecvByteBuff, 1)
      NetPollingState = 1
    END IF
  LOOP UNTIL NeedToCloseNetworkThreads = 1
  NetClose(hServer)
END SUB


SUB NetworkCardSend(BYVAL garbage AS ANY PTR)
  STATIC AS UBYTE FirstRun = 1
  STATIC AS FDSOCKET hClient
  STATIC AS SOCKADDR_IN Server
  STATIC AS INTEGER retvalue
  IF FirstRun = 1 THEN
    hClient = NetSocket(AF_INET,SOCK_DGRAM,0)

    IF (hClient < 0) THEN PRINT "ERROR: Cannot bind to a local socket!" : END

    Server.sin_family=AF_INET
    Server.sin_port=build_port(8764)
    Server.sin_addr=build_addr(NetPlayerIP(1),NetPlayerIP(2),NetPlayerIP(3),NetPlayerIP(4))

    retvalue = NetConnect(hClient,@Server)
    IF retvalue < 0 THEN
      PRINT "ERROR: Could not get a connection..."
      END
    END IF
    FirstRun = 0
  END IF

  DO
    IF NetSendByteBuff < &hFF THEN
      NetWrite(hClient, @NetSendByteBuff, 1)
      NetSendByteBuff = &hFF
    END IF
  LOOP UNTIL NeedToCloseNetworkThreads = 1

  retvalue = NetClose(hClient)
  IF retvalue < 0 THEN
    PRINT "ERROR: Could not close the connection..."
    END
  END IF

END SUB
